<template id="client">
  <div class="container mt-5">
    <h2>Cadastro de users</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="form-group row">
            <div class="col-md-9">
              <input
                type="text"
                class="form-control"
                name="cpf"
                v-model="stringBusca"
                placeholder="cpf"
                required
              />
            </div>
            <div class="col-md-3">
              <a
                class="btn btn-warning float-right"
                @click="buscar(stringBusca)"
              >
                <i class="fas fa-search"></i>buscar
              </a>
            </div>
          </div>
        </div>
      </div>
    </div>

    <table class="table table-striped mt-5">
      <thead>
        <tr>
          <th>cpf</th>
          <th>nome</th>
          <th>email</th>
          <th>nivel de acesso</th>
          <th>ativo inativo</th>
        </tr>
      </thead>

      <tbody>
        <tr v-for="user in users" v-bind:key="user.id">
          <td>{{ user.cpf }}</td>
          <td>{{ user.nome }}</td>
          <td>{{ user.email }}</td>
          <td>{{ user.access }}</td>
          <td>{{ user.flag }}</td>
          <td>
            <a
              href="#"
              class="btn btn-sm btn-danger mx-1"
              @click="excluir(user.id, user.nome)"
            >
              <i class="far fa-trash-alt" title="excluir"></i>
            </a>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      stringBusca: "",
      users: null,
      user: {
        id: null,
        nome: null,
        email: null,
        access: null,
        flag: null,
        cpf: null,
      },
    };
  },
  methods: {
    listar() {
      axios
        .get(this.$MainURL + "/usuarios", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.users = response.data));
    },
    // buscar(cpf) {
    //   if (!cpf) {
    //     this.listar();
    //   } else {
    //     axios
    //       .get(this.$MainURL + "/users/" + cpf, {
    //         headers: {
    //           Authorization: `Bearer ${localStorage.getItem("token")}`,
    //         },
    //       })
    //       .then((response) => (this.users = response.data));
    //   }
    // },
    excluir(id, cod) {
      if (confirm(`Confirma alteração do usuário '${cod}?`));

      axios
        .put(this.$MainURL + "/inative/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`usuário '${cod}' inativado com sucesso`);
          this.listar();
        });
    },
    sal(id) {
      setTimeout(() => {
        this.user.id = id;
        this.axios
          .post(this.$MainURL + "/users", this.users, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then(this.GoBack());
      }, 3000);
    },
    GoBack() {
      window.history.length > 1 ? this.$router.go(-1) : this.$router.push("/");
    },
  },
  mounted() {
    this.listar();
  },
};
</script>

<style scoped></style>
